## orthanc-wsi 3.2+dfsg

=== Applications/CMakeLists.txt ===
# Orthanc - A Lightweight, RESTful DICOM Store
# Copyright (C) 2012-2016 Sebastien Jodogne, Medical Physics
# Department, University Hospital of Liege, Belgium
# Copyright (C) 2017-2023 Osimis S.A., Belgium
# Copyright (C) 2024-2025 Orthanc Team SRL, Belgium
# Copyright (C) 2021-2025 Sebastien Jodogne, ICTEAM UCLouvain, Belgium
#
# This program is free software: you can redistribute it and/or
# modify it under the terms of the GNU Affero General Public License
# as published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.


cmake_minimum_required(VERSION 2.8...4.0)
project(OrthancWSIApplications)

include(${CMAKE_SOURCE_DIR}/../Resources/CMake/Version.cmake)


#####################################################################
## Parameters of the build
#####################################################################

# Generic parameters
SET(STATIC_BUILD OFF CACHE BOOL "Static build of the third-party libraries (necessary for Windows)")
SET(ALLOW_DOWNLOADS OFF CACHE BOOL "Allow CMake to download packages")
SET(ENABLE_PROFILING OFF CACHE BOOL "Whether to enable the generation of profiling information with gprof")

# Advanced parameters to fine-tune linking against system libraries
SET(USE_SYSTEM_LIBTIFF ON CACHE BOOL "Use the system version of libtiff")
SET(USE_SYSTEM_OPENJPEG ON CACHE BOOL "Use the system version of OpenJpeg")



#####################################################################
## Configure mandatory third-party components
#####################################################################

SET(ORTHANC_WSI_DIR ${CMAKE_CURRENT_LIST_DIR}/..)
SET(USE_OPENJPEG_JP2 ON)

include(${CMAKE_SOURCE_DIR}/../Resources/Orthanc/CMake/DownloadOrthancFramework.cmake)  

if (ORTHANC_FRAMEWORK_SOURCE STREQUAL "system")
  if (ORTHANC_FRAMEWORK_USE_SHARED)    
    # https://cmake.org/cmake/help/latest/policy/CMP0167.html
    if (CMAKE_VERSION VERSION_GREATER "3.30")
      find_package(Boost CONFIG)
    else()
      include(FindBoost)
    endif()

    find_package(Boost COMPONENTS filesystem program_options regex system thread date_time)
    
    if (NOT Boost_FOUND)
      message(FATAL_ERROR "Unable to locate Boost on this system")
    endif()

    include(FindDCMTK)
    link_libraries(${Boost_LIBRARIES} ${DCMTK_LIBRARIES} jsoncpp crypto)
  endif()
  
  link_libraries(${ORTHANC_FRAMEWORK_LIBRARIES})
  
else()
  include_directories(${ORTHANC_FRAMEWORK_ROOT})

  UNSET(STANDALONE_BUILD CACHE)
  SET(STANDALONE_BUILD ON)       # Embed DCMTK's dictionaries for static builds

  include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/OrthancFrameworkParameters.cmake)

  SET(ENABLE_CRYPTO_OPTIONS ON)
  SET(ENABLE_DCMTK ON)
  SET(ENABLE_DCMTK_JPEG OFF)          # Disable DCMTK's support for JPEG, that clashes with libtiff
  SET(ENABLE_DCMTK_JPEG_LOSSLESS ON)  # Enable DCMTK's support for JPEG-LS (was disabled in WSI <= 3.1)
  SET(ENABLE_DCMTK_TRANSCODING ON)    # Enable DCMTK's support for transcoding (was disabled in WSI <= 3.1)
  SET(ENABLE_DCMTK_NETWORKING OFF)    # Disable DCMTK's support for DICOM networking
  SET(ENABLE_JPEG ON)
  SET(ENABLE_LOCALE ON)               # Enable support for locales (notably in Boost)
  SET(ENABLE_OPENSSL_ENGINES ON)
  SET(ENABLE_PNG ON)
  SET(ENABLE_SSL ON)
  SET(ENABLE_WEB_CLIENT ON)
  SET(ENABLE_ZLIB ON)

  include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/VisualStudioPrecompiledHeaders.cmake)
  include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/OrthancFrameworkConfiguration.cmake)

  include(${ORTHANC_WSI_DIR}/Resources/CMake/BoostExtendedConfiguration.cmake)

  if (STATIC_BUILD OR NOT USE_SYSTEM_DCMTK)
    # This is a backport of changeset: https://orthanc.uclouvain.be/hg/orthanc/rev/97d69fb5958e
    # TODO - Remove after next upgrade to Orthanc framework > 1.12.7
    include_directories(
      ${DCMTK_SOURCES_DIR}/dcmimgle/include
      )
  endif()
endif()




# Include components specific to WSI
include(${ORTHANC_WSI_DIR}/Resources/CMake/OpenJpegConfiguration.cmake)
include(${ORTHANC_WSI_DIR}/Resources/CMake/LibTiffConfiguration.cmake)



#####################################################################
## Create the list of the source files that depend upon the
## precompiled headers
#####################################################################

set(ORTHANC_WSI_SOURCES
  ${ORTHANC_WSI_DIR}/Framework/Algorithms/PyramidReader.cpp
  ${ORTHANC_WSI_DIR}/Framework/Algorithms/ReconstructPyramidCommand.cpp
  ${ORTHANC_WSI_DIR}/Framework/Algorithms/TranscodeTileCommand.cpp
  ${ORTHANC_WSI_DIR}/Framework/ColorSpaces.cpp
  ${ORTHANC_WSI_DIR}/Framework/DicomToolbox.cpp
  ${ORTHANC_WSI_DIR}/Framework/DicomizerParameters.cpp
  ${ORTHANC_WSI_DIR}/Framework/Enumerations.cpp
  ${ORTHANC_WSI_DIR}/Framework/ImageToolbox.cpp
  ${ORTHANC_WSI_DIR}/Framework/ImagedVolumeParameters.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/CytomineImage.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/DecodedPyramidCache.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/DecodedTiledPyramid.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/DicomPyramid.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/DicomPyramidInstance.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/DicomPyramidLevel.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/HierarchicalTiff.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/OnTheFlyPyramid.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/OpenSlideLibrary.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/OpenSlidePyramid.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/PlainTiff.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/PyramidWithRawTiles.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/SingleLevelDecodedPyramid.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/TiledPyramidStatistics.cpp
  ${ORTHANC_WSI_DIR}/Framework/Jpeg2000Reader.cpp
  ${ORTHANC_WSI_DIR}/Framework/Jpeg2000Writer.cpp
  ${ORTHANC_WSI_DIR}/Framework/MultiThreading/BagOfTasksProcessor.cpp
  ${ORTHANC_WSI_DIR}/Framework/Outputs/DicomPyramidWriter.cpp
  ${ORTHANC_WSI_DIR}/Framework/Outputs/HierarchicalTiffWriter.cpp
  ${ORTHANC_WSI_DIR}/Framework/Outputs/InMemoryTiledImage.cpp
  ${ORTHANC_WSI_DIR}/Framework/Outputs/MultiframeDicomWriter.cpp
  ${ORTHANC_WSI_DIR}/Framework/Outputs/PyramidWriterBase.cpp
  ${ORTHANC_WSI_DIR}/Framework/Outputs/TruncatedPyramidWriter.cpp
  ${ORTHANC_WSI_DIR}/Framework/Targets/FolderTarget.cpp
  ${ORTHANC_WSI_DIR}/Framework/Targets/OrthancTarget.cpp
  ${ORTHANC_WSI_DIR}/Framework/TiffReader.cpp
  )

EmbedResources(
  ${DCMTK_DICTIONARIES}
  BRIGHTFIELD_OPTICAL_PATH  ${ORTHANC_WSI_DIR}/Resources/BrightfieldOpticalPath.json
  SAMPLE_DATASET            ${ORTHANC_WSI_DIR}/Resources/SampleDataset.json
  SRGB_ICC_PROFILE          ${ORTHANC_WSI_DIR}/Resources/sRGB.icc
  )

add_definitions(
  -DORTHANC_ENABLE_LOGGING_PLUGIN=0
  )


#####################################################################
## Setup precompiled headers for Microsoft Visual Studio
#####################################################################

if (MSVC)
  add_definitions(-DORTHANC_USE_PRECOMPILED_HEADERS=1)

  set(TMP
    ${ORTHANC_CORE_SOURCES_INTERNAL}
    ${ORTHANC_DICOM_SOURCES_INTERNAL}
    )
  
  ADD_VISUAL_STUDIO_PRECOMPILED_HEADERS(
    "PrecompiledHeaders.h" "${ORTHANC_FRAMEWORK_ROOT}/PrecompiledHeaders.cpp"
    TMP ORTHANC_CORE_PCH)

  ADD_VISUAL_STUDIO_PRECOMPILED_HEADERS(
    "PrecompiledHeadersWSI.h" "${ORTHANC_WSI_DIR}/Framework/PrecompiledHeadersWSI.cpp"
    ORTHANC_WSI_SOURCES ORTHANC_WSI_PCH)

  source_group(ThirdParty\\OrthancCore FILES ${ORTHANC_CORE_SOURCES})
endif()


#####################################################################
## Create the static library containing the framework
#####################################################################

add_library(OrthancWSIFramework STATIC
  ${ORTHANC_WSI_PCH}
  ${ORTHANC_WSI_SOURCES}

  ${ORTHANC_CORE_PCH}
  ${ORTHANC_CORE_SOURCES_INTERNAL}
  ${ORTHANC_CORE_SOURCES_DEPENDENCIES}
  ${ORTHANC_DICOM_SOURCES_INTERNAL}
  ${ORTHANC_DICOM_SOURCES_DEPENDENCIES}
  ${AUTOGENERATED_SOURCES}
  ${BOOST_EXTENDED_SOURCES}

  ${ORTHANC_WSI_DIR}/Resources/Orthanc/Stone/DicomDatasetReader.cpp
  ${ORTHANC_WSI_DIR}/Resources/Orthanc/Stone/FullOrthancDataset.cpp
  ${ORTHANC_WSI_DIR}/Resources/Orthanc/Stone/IOrthancConnection.cpp
  ${ORTHANC_WSI_DIR}/Resources/Orthanc/Stone/OrthancHttpConnection.cpp
  ${ORTHANC_WSI_DIR}/Resources/Orthanc/StoneToolbox.cpp

  # Mandatory components
  ${LIBTIFF_SOURCES}
  ${OPENJPEG_SOURCES}
  )

if (COMMAND DefineSourceBasenameForTarget)
  DefineSourceBasenameForTarget(OrthancWSIFramework)
endif()


#####################################################################
## Build the WSI DICOM-izer
#####################################################################

# Create the Windows resources, if need be
if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
  execute_process(
    COMMAND 
    ${PYTHON_EXECUTABLE} ${ORTHANC_FRAMEWORK_ROOT}/../Resources/WindowsResources.py
    ${ORTHANC_WSI_VERSION} OrthancWSIDicomizer OrthancWSIDicomizer.exe "Companion tool to Orthanc for whole-slide imaging"
    ERROR_VARIABLE Failure
    OUTPUT_FILE ${AUTOGENERATED_DIR}/OrthancWSIDicomizer.rc
    )

  if (Failure)
    message(FATAL_ERROR "Error while computing the version information: ${Failure}")
  endif()

  set(DICOMIZER_RESOURCES ${AUTOGENERATED_DIR}/OrthancWSIDicomizer.rc)
endif()


add_executable(OrthancWSIDicomizer
  Dicomizer.cpp
  ApplicationToolbox.cpp
  ${DICOMIZER_RESOURCES}
  )

if (COMMAND DefineSourceBasenameForTarget)
  DefineSourceBasenameForTarget(OrthancWSIDicomizer)
endif()

target_link_libraries(OrthancWSIDicomizer OrthancWSIFramework ${DCMTK_LIBRARIES})

install(
  TARGETS OrthancWSIDicomizer
  RUNTIME DESTINATION bin
  )


#####################################################################
## Build the DICOM-to-TIFF conversion tool
#####################################################################

# Create the Windows resources, if need be
if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
  execute_process(
    COMMAND 
    ${PYTHON_EXECUTABLE} ${ORTHANC_FRAMEWORK_ROOT}/../Resources/WindowsResources.py
    ${ORTHANC_WSI_VERSION} OrthancWSIDicomToTiff OrthancWSIDicomToTiff.exe "Companion tool to Orthanc for whole-slide imaging"
    ERROR_VARIABLE Failure
    OUTPUT_FILE ${AUTOGENERATED_DIR}/OrthancWSIDicomToTiff.rc
    )

  if (Failure)
    message(FATAL_ERROR "Error while computing the version information: ${Failure}")
  endif()

  set(DICOM_TO_TIFF_RESOURCES ${AUTOGENERATED_DIR}/OrthancWSIDicomToTiff.rc)
endif()


add_executable(OrthancWSIDicomToTiff
  DicomToTiff.cpp
  ApplicationToolbox.cpp
  ${DICOM_TO_TIFF_RESOURCES}
  )

if (COMMAND DefineSourceBasenameForTarget)
  DefineSourceBasenameForTarget(OrthancWSIDicomToTiff)
endif()

target_link_libraries(OrthancWSIDicomToTiff OrthancWSIFramework ${DCMTK_LIBRARIES})

install(
  TARGETS OrthancWSIDicomToTiff
  RUNTIME DESTINATION bin
  )


#####################################################################
## Generate the documentation if Doxygen is present
#####################################################################

find_package(Doxygen)
if (DOXYGEN_FOUND)
  configure_file(
    ${ORTHANC_WSI_DIR}/Resources/OrthancWSI.doxygen
    ${CMAKE_CURRENT_BINARY_DIR}/OrthancWSI.doxygen
    @ONLY)

  add_custom_target(doc
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/OrthancWSI.doxygen
    COMMENT "Generating documentation with Doxygen" VERBATIM
    )
else()
  message("Doxygen not found. The documentation will not be built.")
endif()

=== ViewerPlugin/CMakeLists.txt ===
# Orthanc - A Lightweight, RESTful DICOM Store
# Copyright (C) 2012-2016 Sebastien Jodogne, Medical Physics
# Department, University Hospital of Liege, Belgium
# Copyright (C) 2017-2023 Osimis S.A., Belgium
# Copyright (C) 2024-2025 Orthanc Team SRL, Belgium
# Copyright (C) 2021-2025 Sebastien Jodogne, ICTEAM UCLouvain, Belgium
#
# This program is free software: you can redistribute it and/or
# modify it under the terms of the GNU Affero General Public License
# as published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.


cmake_minimum_required(VERSION 2.8...4.0)
project(OrthancWSIPlugin)

include(${CMAKE_SOURCE_DIR}/../Resources/CMake/Version.cmake)


#####################################################################
## Parameters of the build
#####################################################################

# Generic parameters
SET(STATIC_BUILD OFF CACHE BOOL "Static build of the third-party libraries (necessary for Windows)")
SET(ALLOW_DOWNLOADS OFF CACHE BOOL "Allow CMake to download packages")

# Advanced parameters to fine-tune linking against system libraries
SET(USE_SYSTEM_OPENJPEG ON CACHE BOOL "Use the system version of OpenJpeg")
SET(USE_SYSTEM_ORTHANC_SDK ON CACHE BOOL "Use the system version of the Orthanc plugin SDK")

# Parameters related to OpenLayers
SET(USE_SYSTEM_OPENLAYERS OFF CACHE BOOL "Use the system version of OpenLayers")
SET(OPENLAYERS_CSS "" CACHE FILEPATH "Path to the system version of OpenLayers CSS")
SET(OPENLAYERS_JS "" CACHE FILEPATH "Path to the system version of OpenLayers JavaScript")


#####################################################################
## Configure mandatory third-party components
#####################################################################

SET(ORTHANC_WSI_DIR ${CMAKE_CURRENT_LIST_DIR}/..)
SET(USE_OPENJPEG_JP2 ON)

include(${CMAKE_SOURCE_DIR}/../Resources/Orthanc/CMake/DownloadOrthancFramework.cmake)

if (ORTHANC_FRAMEWORK_SOURCE STREQUAL "system")
  if (ORTHANC_FRAMEWORK_USE_SHARED)
    # https://cmake.org/cmake/help/latest/policy/CMP0167.html
    if (CMAKE_VERSION VERSION_GREATER "3.30")
      find_package(Boost CONFIG)
    else()
      include(FindBoost)
    endif()

    find_package(Boost COMPONENTS system thread)
    
    if (NOT Boost_FOUND)
      message(FATAL_ERROR "Unable to locate Boost on this system")
    endif()
    
    include(FindDCMTK)
    link_libraries(${Boost_LIBRARIES} ${DCMTK_LIBRARIES} jsoncpp)
  endif()
  
  link_libraries(${ORTHANC_FRAMEWORK_LIBRARIES})
  
else()
  include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/OrthancFrameworkParameters.cmake)

  set(ENABLE_LOCALE OFF)         # Disable support for locales (notably in Boost)
  set(ENABLE_ZLIB ON)
  set(ENABLE_PNG ON)
  set(ENABLE_JPEG ON)

  include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/VisualStudioPrecompiledHeaders.cmake)
  include(${ORTHANC_FRAMEWORK_ROOT}/../Resources/CMake/OrthancFrameworkConfiguration.cmake)

  include_directories(${ORTHANC_FRAMEWORK_ROOT})
endif()

include(${ORTHANC_WSI_DIR}/Resources/Orthanc/Plugins/OrthancPluginsExports.cmake)

# Include components specific to WSI
include(${ORTHANC_WSI_DIR}/Resources/CMake/Version.cmake)
include(${ORTHANC_WSI_DIR}/Resources/CMake/OpenJpegConfiguration.cmake)


#####################################################################
## Find the Orthanc SDK
#####################################################################

if (STATIC_BUILD OR NOT USE_SYSTEM_ORTHANC_SDK)
  include_directories(${CMAKE_SOURCE_DIR}/../Resources/Orthanc/Sdk-1.7.0)
else ()
  CHECK_INCLUDE_FILE_CXX(orthanc/OrthancCPlugin.h HAVE_ORTHANC_H)
  if (NOT HAVE_ORTHANC_H)
    message(FATAL_ERROR "Please install the headers of the Orthanc plugins SDK")
  endif()
endif()


#####################################################################
## Platform-specific configuration
#####################################################################

add_definitions(
  -DHAS_ORTHANC_EXCEPTION=1
  -DORTHANC_ENABLE_LOGGING_PLUGIN=1
  -DORTHANC_FRAMEWORK_BUILDING_PLUGIN=1
  )

if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux" OR
    ${CMAKE_SYSTEM_NAME} STREQUAL "kFreeBSD" OR
    ${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
  link_libraries(rt)

elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
  execute_process(
    COMMAND 
    ${PYTHON_EXECUTABLE} ${ORTHANC_FRAMEWORK_ROOT}/../Resources/WindowsResources.py
    ${ORTHANC_WSI_VERSION} "OrthancWSI" OrthancWSI.dll "Whole-slide imaging plugin for Orthanc"
    ERROR_VARIABLE Failure
    OUTPUT_FILE ${AUTOGENERATED_DIR}/Version.rc
    )

  if (Failure)
    message(FATAL_ERROR "Error while computing the version information: ${Failure}")
  endif()

  list(APPEND AUTOGENERATED_SOURCES  ${AUTOGENERATED_DIR}/Version.rc)
endif()

if (APPLE)
  SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -framework CoreFoundation")
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -framework CoreFoundation")
endif()


#####################################################################
## Prepare OpenLayers
#####################################################################

if (STATIC_BUILD OR NOT USE_SYSTEM_OPENLAYERS)
  DownloadPackage(
    "e15da1e1f803e69a8ca1e0ed11f0cf24"
    "https://orthanc.uclouvain.be/downloads/third-party-downloads/WSI/openlayers-10.4.0-package.tar.gz"
    "openlayers-10.4.0-package")
  
  set(OPENLAYERS_RESOURCES
    OPENLAYERS_CSS  ${CMAKE_CURRENT_BINARY_DIR}/openlayers-10.4.0-package/ol.css
    OPENLAYERS_JS   ${CMAKE_CURRENT_BINARY_DIR}/openlayers-10.4.0-package/dist/ol.js
    )

else()
  if (OPENLAYERS_CSS STREQUAL "")
    message(FATAL_ERROR "The option OPENLAYERS_CSS is not set")
  endif()

  if (OPENLAYERS_JS STREQUAL "")
    message(FATAL_ERROR "The option OPENLAYERS_JS is not set")
  endif()

  set(OPENLAYERS_RESOURCES
    OPENLAYERS_CSS  ${OPENLAYERS_CSS}
    OPENLAYERS_JS   ${OPENLAYERS_JS}
    )  
endif()

EmbedResources(
  ${OPENLAYERS_RESOURCES}
  ORTHANC_EXPLORER     ${CMAKE_SOURCE_DIR}/OrthancExplorer.js
  VIEWER_HTML          ${CMAKE_SOURCE_DIR}/viewer.html
  VIEWER_JS            ${CMAKE_SOURCE_DIR}/viewer.js
  MIRADOR_HTML         ${CMAKE_SOURCE_DIR}/mirador.html
  OPEN_SEADRAGON_HTML  ${CMAKE_SOURCE_DIR}/openseadragon.html
  )


#####################################################################
## Create the list of the source files that depend upon the
## precompiled headers
#####################################################################

set(ORTHANC_WSI_SOURCES
  DicomPyramidCache.cpp
  IIIF.cpp
  OrthancPluginConnection.cpp
  OrthancPyramidFrameFetcher.cpp
  Plugin.cpp
  RawTile.cpp

  ${ORTHANC_WSI_DIR}/Framework/ColorSpaces.cpp
  ${ORTHANC_WSI_DIR}/Framework/DicomToolbox.cpp
  ${ORTHANC_WSI_DIR}/Framework/Enumerations.cpp
  ${ORTHANC_WSI_DIR}/Framework/ImageToolbox.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/DecodedPyramidCache.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/DecodedTiledPyramid.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/DicomPyramid.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/DicomPyramidInstance.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/DicomPyramidLevel.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/OnTheFlyPyramid.cpp
  ${ORTHANC_WSI_DIR}/Framework/Inputs/PyramidWithRawTiles.cpp
  ${ORTHANC_WSI_DIR}/Framework/Jpeg2000Reader.cpp
  ${ORTHANC_WSI_DIR}/Framework/Jpeg2000Writer.cpp

  ${ORTHANC_WSI_DIR}/Resources/Orthanc/Plugins/OrthancPluginCppWrapper.cpp
  ${ORTHANC_WSI_DIR}/Resources/Orthanc/Stone/DicomDatasetReader.cpp
  ${ORTHANC_WSI_DIR}/Resources/Orthanc/Stone/FullOrthancDataset.cpp
  ${ORTHANC_WSI_DIR}/Resources/Orthanc/Stone/IOrthancConnection.cpp
  ${ORTHANC_WSI_DIR}/Resources/Orthanc/StoneToolbox.cpp
  )


#####################################################################
## Setup precompiled headers for Microsoft Visual Studio
#####################################################################

if (MSVC)
  add_definitions(-DORTHANC_USE_PRECOMPILED_HEADERS=1)

  ADD_VISUAL_STUDIO_PRECOMPILED_HEADERS(
    "PrecompiledHeaders.h" "${ORTHANC_FRAMEWORK_ROOT}/PrecompiledHeaders.cpp"
    ORTHANC_CORE_SOURCES_INTERNAL ORTHANC_CORE_PCH)

  ADD_VISUAL_STUDIO_PRECOMPILED_HEADERS(
    "PrecompiledHeadersWSI.h" "${ORTHANC_WSI_DIR}/Framework/PrecompiledHeadersWSI.cpp"
    ORTHANC_WSI_SOURCES ORTHANC_WSI_PCH)

  source_group(ThirdParty\\OrthancCore FILES ${ORTHANC_CORE_SOURCES})
endif()


#####################################################################
## Create the plugin
#####################################################################

add_library(OrthancWSI SHARED
  ${ORTHANC_WSI_PCH}
  ${ORTHANC_WSI_SOURCES}
  ${ORTHANC_CORE_PCH}
  ${ORTHANC_CORE_SOURCES_INTERNAL}
  ${ORTHANC_CORE_SOURCES_DEPENDENCIES}
  ${AUTOGENERATED_SOURCES}
  ${OPENJPEG_SOURCES}
  )

if (COMMAND DefineSourceBasenameForTarget)
  DefineSourceBasenameForTarget(OrthancWSI)
endif()

message("Setting the version of the library to ${ORTHANC_WSI_VERSION}")
set_target_properties(OrthancWSI PROPERTIES 
  VERSION ${ORTHANC_WSI_VERSION} 
  SOVERSION ${ORTHANC_WSI_VERSION})

install(
  TARGETS OrthancWSI
  RUNTIME DESTINATION lib    # Destination for Windows
  LIBRARY DESTINATION share/orthanc/plugins    # Destination for Linux
  )

=== debian/changelog ===
orthanc-wsi (3.2+dfsg-7build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Aug 2025 08:18:43 +0200

orthanc-wsi (3.2+dfsg-7) unstable; urgency=medium

  * Relax initialization tests. Closes: #1104044

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sun, 27 Apr 2025 20:37:28 +0200

orthanc-wsi (3.2+dfsg-6) unstable; urgency=medium

  * Fix d/tests/control

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sun, 27 Apr 2025 13:09:46 +0200

orthanc-wsi (3.2+dfsg-5) unstable; urgency=medium

  * Increased verbosity of "run-dicom-image-transcode-test"

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sun, 27 Apr 2025 12:15:25 +0200

orthanc-wsi (3.2+dfsg-4) unstable; urgency=medium

  * Team upload.
  * d/t/control: tests depend on curl.
  * d/control: depend on dcmtk >= 3.6.9-5.
    dcmtk 3.6.9-5 resolved #1098944 by making the data directory
    unversioned again, but decoupling the two packages must occur at or
    after dcmtk 3.6.9-5, otherwise the newer orthanc will fail to start
    against the slightly older dcmtk package.
  * d/{,t/}control: depend on orthanc >= 1.12.7+dfsg-2.
    The orthanc version needs to be new enough to have built against a
    dcmtk version that reverted versioned dcmtk data directory.

 -- Étienne Mollier <emollier@debian.org>  Wed, 23 Apr 2025 21:05:33 +0200

orthanc-wsi (3.2+dfsg-3) unstable; urgency=medium

  [ Étienne Mollier ]
  * Fix "d/tests/run-dicom-image-transcode-test" that stopped on error.

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Tue, 22 Apr 2025 22:50:58 +0200

orthanc-wsi (3.2+dfsg-2) unstable; urgency=medium

  * Fix "d/tests/run-dicom-image-transcode-test" that was not waiting
    for the orthanc service to be in a healthy state.
  * Added Build-Depends on dcmtk-data >= 3.6.9-5. Closes: #1103505

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Tue, 22 Apr 2025 11:00:13 +0200

orthanc-wsi (3.2+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Tue, 08 Apr 2025 17:21:38 +0200

orthanc-wsi (3.1+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 17 Mar 2025 18:01:01 +0100

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk   # To access the "DEB_VERSION" variable

export UPSTREAM_VERSION := $(shell echo "$(DEB_VERSION)" | cut -d '+' -f 1)
export VIEWER_TARGET := libOrthancWSI.so
export DEB_BUILD_MAINT_OPTIONS := hardening=+all

# Disable assert() checking from upstream project, for best performance
# https://lists.debian.org/debian-med/2018/04/msg00132.html
export DEB_CFLAGS_MAINT_APPEND=-DNDEBUG
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@

ORTHANC_FRAMEWORK_LIBRARIES="boost_filesystem boost_iostreams boost_locale boost_regex boost_thread jsoncpp pugixml uuid  dcmdata ofstd jpeg png curl boost_program_options dcmjpeg dcmjpls dcmimage dl crypto z"

CMAKE_APPLICATIONS_EXTRA_FLAGS += \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DORTHANC_FRAMEWORK_SOURCE=system \
        -DORTHANC_FRAMEWORK_USE_SHARED:BOOL=OFF \
        -DORTHANC_FRAMEWORK_ADDITIONAL_LIBRARIES=${ORTHANC_FRAMEWORK_LIBRARIES} \
	-DCMAKE_BUILD_TYPE=None   # The build type must be set to None, see #711515

CMAKE_VIEWER_EXTRA_FLAGS += \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DORTHANC_FRAMEWORK_SOURCE=system \
        -DORTHANC_FRAMEWORK_USE_SHARED:BOOL=OFF \
        -DORTHANC_FRAMEWORK_ADDITIONAL_LIBRARIES=${ORTHANC_FRAMEWORK_LIBRARIES} \
	-DUSE_SYSTEM_OPENLAYERS:BOOL=ON \
	-DOPENLAYERS_CSS=$(CURDIR)/BuildViewer/ol.css \
	-DOPENLAYERS_JS=$(CURDIR)/BuildViewer/ol.js \
	-DCMAKE_BUILD_TYPE=None   # The build type must be set to None, see #711515

# Automated generation of the "Built-Using" attribute in "d/control"
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=989126
# Adapted from:
# https://wiki.debian.org/SIMDEverywhere#Approach (Point 6)
#
# In addition, automated generation of the "Depends" on "dcmtk-data"
# to access the DICOM dictionaries during runtime:
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1076541
override_dh_gencontrol:
	dh_gencontrol -- \
		-Vorthancframework:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W liborthancframework-dev)" \
		-Vdcmtk-data:Depends="$(shell dpkg-query -f '$${binary:Package} (>= $${source:Upstream-Version}), ' -W dcmtk-data)"

override_dh_auto_configure:
        # Configure the command-line tools
	mkdir BuildApplications
	dh_auto_configure --builddirectory=BuildApplications \
			  --sourcedirectory=Applications \
			  -- $(CMAKE_APPLICATIONS_EXTRA_FLAGS)

        # Copy OpenLayers distribution where expected by the build scripts
	mkdir BuildViewer
	cp debian/missing-sources/openlayers-10.4.0-package/dist/ol.js BuildViewer/ol.js
	cp debian/missing-sources/openlayers-10.4.0-package/ol.css BuildViewer/ol.css

        # Configure the Web viewer plugin
	dh_auto_configure --builddirectory=BuildViewer \
			  --sourcedirectory=ViewerPlugin \
			  -- $(CMAKE_VIEWER_EXTRA_FLAGS)

override_dh_clean:
	dh_clean BuildApplications/
	dh_clean BuildViewer/

override_dh_auto_build:
        # Build the command-line tools
	dh_auto_build --builddirectory=BuildApplications \
		      --sourcedirectory=Applications

        # Build the Web viewer plugin
	dh_auto_build --builddirectory=BuildViewer \
		      --sourcedirectory=ViewerPlugin

override_dh_auto_install:
        # Install the command-line tools
	dh_auto_install --builddirectory=BuildApplications

        # Install the plugin
	dh_install BuildViewer/${VIEWER_TARGET}.${UPSTREAM_VERSION} usr/lib/orthanc

override_dh_link:
	dh_link usr/lib/orthanc/${VIEWER_TARGET}.${UPSTREAM_VERSION} \
		usr/share/orthanc/plugins/${VIEWER_TARGET}

override_dh_installchangelogs:
	dh_installchangelogs -k NEWS

=== debian/watch ===
version=4
opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
https://orthanc.uclouvain.be/downloads/sources/orthanc-wsi/index.html OrthancWSI-(\d\S*)\.tar\.gz

## orthanc-wsi 3.3%2Bdfsg

=== Applications/CMakeLists.txt ===
--- 
+++ 
@@ -67,7 +67,8 @@
     include(FindDCMTK)
     link_libraries(${Boost_LIBRARIES} ${DCMTK_LIBRARIES} jsoncpp crypto)
   endif()
-  
+
+  add_definitions(-DORTHANC_ENABLE_DCMTK=1)
   link_libraries(${ORTHANC_FRAMEWORK_LIBRARIES})
   
 else()

## orthanc-wsi 3.3+dfsg

=== ViewerPlugin/CMakeLists.txt ===
--- 
+++ 
@@ -32,15 +32,11 @@
 # Generic parameters
 SET(STATIC_BUILD OFF CACHE BOOL "Static build of the third-party libraries (necessary for Windows)")
 SET(ALLOW_DOWNLOADS OFF CACHE BOOL "Allow CMake to download packages")
+SET(STANDALONE_BUILD ON CACHE BOOL "Standalone build (all the resources are embedded, necessary for releases)")
 
 # Advanced parameters to fine-tune linking against system libraries
 SET(USE_SYSTEM_OPENJPEG ON CACHE BOOL "Use the system version of OpenJpeg")
 SET(USE_SYSTEM_ORTHANC_SDK ON CACHE BOOL "Use the system version of the Orthanc plugin SDK")
-
-# Parameters related to OpenLayers
-SET(USE_SYSTEM_OPENLAYERS OFF CACHE BOOL "Use the system version of OpenLayers")
-SET(OPENLAYERS_CSS "" CACHE FILEPATH "Path to the system version of OpenLayers CSS")
-SET(OPENLAYERS_JS "" CACHE FILEPATH "Path to the system version of OpenLayers JavaScript")
 
 
 #####################################################################
@@ -70,7 +66,8 @@
     include(FindDCMTK)
     link_libraries(${Boost_LIBRARIES} ${DCMTK_LIBRARIES} jsoncpp)
   endif()
-  
+
+  add_definitions(-DORTHANC_ENABLE_DCMTK=1)
   link_libraries(${ORTHANC_FRAMEWORK_LIBRARIES})
   
 else()
@@ -146,40 +143,28 @@
 
 
 #####################################################################
-## Prepare OpenLayers
-#####################################################################
-
-if (STATIC_BUILD OR NOT USE_SYSTEM_OPENLAYERS)
-  DownloadPackage(
-    "e15da1e1f803e69a8ca1e0ed11f0cf24"
-    "https://orthanc.uclouvain.be/downloads/third-party-downloads/WSI/openlayers-10.4.0-package.tar.gz"
-    "openlayers-10.4.0-package")
-  
-  set(OPENLAYERS_RESOURCES
-    OPENLAYERS_CSS  ${CMAKE_CURRENT_BINARY_DIR}/openlayers-10.4.0-package/ol.css
-    OPENLAYERS_JS   ${CMAKE_CURRENT_BINARY_DIR}/openlayers-10.4.0-package/dist/ol.js
+## Prepare JavaScript libraries
+#####################################################################
+
+include(${CMAKE_SOURCE_DIR}/../Resources/CMake/JavaScriptLibraries.cmake)
+
+if (STANDALONE_BUILD)
+  add_definitions(-DORTHANC_STANDALONE=1)
+  set(VIEWER_RESOURCES
+    VIEWER_HTML          ${CMAKE_SOURCE_DIR}/viewer.html
+    VIEWER_JS            ${CMAKE_SOURCE_DIR}/viewer.js
     )
-
 else()
-  if (OPENLAYERS_CSS STREQUAL "")
-    message(FATAL_ERROR "The option OPENLAYERS_CSS is not set")
-  endif()
-
-  if (OPENLAYERS_JS STREQUAL "")
-    message(FATAL_ERROR "The option OPENLAYERS_JS is not set")
-  endif()
-
-  set(OPENLAYERS_RESOURCES
-    OPENLAYERS_CSS  ${OPENLAYERS_CSS}
-    OPENLAYERS_JS   ${OPENLAYERS_JS}
-    )  
+  add_definitions(
+    -DORTHANC_STANDALONE=0
+    -DPLUGIN_SOURCE_DIR="${CMAKE_SOURCE_DIR}"
+    )
 endif()
 
 EmbedResources(
-  ${OPENLAYERS_RESOURCES}
+  ${VIEWER_RESOURCES}
+  JAVASCRIPT_LIBS      ${JAVASCRIPT_LIBS_DIR}
   ORTHANC_EXPLORER     ${CMAKE_SOURCE_DIR}/OrthancExplorer.js
-  VIEWER_HTML          ${CMAKE_SOURCE_DIR}/viewer.html
-  VIEWER_JS            ${CMAKE_SOURCE_DIR}/viewer.js
   MIRADOR_HTML         ${CMAKE_SOURCE_DIR}/mirador.html
   OPEN_SEADRAGON_HTML  ${CMAKE_SOURCE_DIR}/openseadragon.html
   )

=== debian/changelog ===
orthanc-wsi (3.3+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sun, 09 Nov 2025 20:51:26 +0100

=== debian/control ===
Source: orthanc-wsi
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libcurl4-openssl-dev | libcurl4-dev,
               libdcmtk-dev (>= 3.6.9-5),
               libjs-bootstrap5,
               libopenjp2-7-dev,
               liborthancframework-dev (>= 1.12.7+dfsg-2),
               libpng-dev,
               libssl-dev,
               libtiff-dev,
               node-popper2,
               orthanc-dev,
               unzip,
               uuid-dev,
               zlib1g-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/orthanc-wsi
Vcs-Git: https://salsa.debian.org/med-team/orthanc-wsi.git
Homepage: https://orthanc.uclouvain.be/book/plugins/wsi.html
Rules-Requires-Root: no

Package: orthanc-wsi
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         dcmtk-data (>= 3.6.9-5)
Recommends: orthanc (>= 1.12.7+dfsg-2),
            libopenslide0
Built-Using: ${orthancframework:Built-Using}
Description: Whole-slide imaging support for Orthanc (digital pathology)
 Orthanc-WSI brings support of whole-slide imaging for digital
 pathology into Orthanc, the lightweight, RESTful Vendor Neutral
 Archive for medical imaging.
 .
 This package contains two command-line tools to convert whole-slide
 images to and from DICOM. Support for proprietary file formats is
 available through OpenSlide. The package also contains an Orthanc
 plugin to display such DICOM images by any standard Web browser. The
 implementation follows DICOM Supplement 145.

=== debian/rules ===
--- 
+++ 
@@ -16,21 +16,11 @@
 
 ORTHANC_FRAMEWORK_LIBRARIES="boost_filesystem boost_iostreams boost_locale boost_regex boost_thread jsoncpp pugixml uuid  dcmdata ofstd jpeg png curl boost_program_options dcmjpeg dcmjpls dcmimage dl crypto z"
 
-CMAKE_APPLICATIONS_EXTRA_FLAGS += \
+CMAKE_EXTRA_FLAGS += \
 	-DCMAKE_SKIP_RPATH:BOOL=ON \
 	-DORTHANC_FRAMEWORK_SOURCE=system \
         -DORTHANC_FRAMEWORK_USE_SHARED:BOOL=OFF \
         -DORTHANC_FRAMEWORK_ADDITIONAL_LIBRARIES=${ORTHANC_FRAMEWORK_LIBRARIES} \
-	-DCMAKE_BUILD_TYPE=None   # The build type must be set to None, see #711515
-
-CMAKE_VIEWER_EXTRA_FLAGS += \
-	-DCMAKE_SKIP_RPATH:BOOL=ON \
-	-DORTHANC_FRAMEWORK_SOURCE=system \
-        -DORTHANC_FRAMEWORK_USE_SHARED:BOOL=OFF \
-        -DORTHANC_FRAMEWORK_ADDITIONAL_LIBRARIES=${ORTHANC_FRAMEWORK_LIBRARIES} \
-	-DUSE_SYSTEM_OPENLAYERS:BOOL=ON \
-	-DOPENLAYERS_CSS=$(CURDIR)/BuildViewer/ol.css \
-	-DOPENLAYERS_JS=$(CURDIR)/BuildViewer/ol.js \
 	-DCMAKE_BUILD_TYPE=None   # The build type must be set to None, see #711515
 
 # Automated generation of the "Built-Using" attribute in "d/control"
@@ -51,17 +41,12 @@
 	mkdir BuildApplications
 	dh_auto_configure --builddirectory=BuildApplications \
 			  --sourcedirectory=Applications \
-			  -- $(CMAKE_APPLICATIONS_EXTRA_FLAGS)
-
-        # Copy OpenLayers distribution where expected by the build scripts
-	mkdir BuildViewer
-	cp debian/missing-sources/openlayers-10.4.0-package/dist/ol.js BuildViewer/ol.js
-	cp debian/missing-sources/openlayers-10.4.0-package/ol.css BuildViewer/ol.css
+			  -- $(CMAKE_EXTRA_FLAGS)
 
         # Configure the Web viewer plugin
 	dh_auto_configure --builddirectory=BuildViewer \
 			  --sourcedirectory=ViewerPlugin \
-			  -- $(CMAKE_VIEWER_EXTRA_FLAGS)
+			  -- $(CMAKE_EXTRA_FLAGS)
 
 override_dh_clean:
 	dh_clean BuildApplications/

=== debian/tests/control ===
Tests: run-generate-dataset-test, run-dicom-image-transcode-test
Depends: orthanc (>= 1.12.7+dfsg-2), orthanc-wsi, curl, procps
Restrictions: needs-sudo, allow-stderr
